=== tests/analysis/CMakeLists.txt ===
option(ENABLE_TEST_ANALYSIS "Enable Analysis Tests" ON)

if (ENABLE_TEST_ANALYSIS)
    add_subdirectory(convolution)
    add_subdirectory(correlation)
    add_subdirectory(differentiation)
    add_subdirectory(fit)
    add_subdirectory(fourier)
    add_subdirectory(hilberttransform)
    add_subdirectory(integration)
    add_subdirectory(interpolation)
    add_subdirectory(smooth)
endif()
